#/* Copyright (C) 2003  Vesa Karvonen
# *
# * Permission to copy, use, modify, sell and distribute this software is
# * granted provided this copyright notice appears in all copies. This
# * software is provided "as is" without express or implied warranty, and with
# * no claim as to its suitability for any purpose.
# */
#
#include "aux.hpp"
#include "sm.hpp"
#include "ops.hpp"
#include "stx.hpp"
#include "env.hpp"
#include "defs.hpp"
#
#/* Reducer based on environments */
#
#define PP_EVAL(t) PP_CADR(_,PP_SM((t,_),(PP_EVAL,(PP_ENV_MAKE(_),(PP_TO_LAMBDA,PP_SM_STOP)))))
#
#define PP_EVAL_OP(t_ts,env_ps) PP_DISPATCH(PP_EVAL_,t_ts)(PP_CAR t_ts,PP_CDR t_ts,PP_CAR env_ps,PP_CDR env_ps)
#define PP_EVAL_CLOSURE(t,ts,env,ps) ((t,ts),ps)
#define PP_EVAL_LAMBDA(t,ts,env,ps) ((CLOSURE(env,PP_VAR(t),PP_TERM(t)),ts),ps)
#define PP_EVAL_APPLY(t,ts,env,ps) ((PP_CDR t,(PP_CAR t,ts)),(PP_EVAL,(env,(PP_SWAP,(PP_EVAL,(env,(PP_APPLY,ps)))))))
#define PP_EVAL_SYMBOL(t,ts,env,ps) ((PP_ENV_GET(t,env),ts),ps)
#
#define PP_APPLY_OP(c0_c1_ts,ps) ((PP_TERM(PP_CAR c0_c1_ts),PP_CDDR c0_c1_ts),(PP_EVAL,(PP_ENV_SET(PP_VAR(PP_CAR c0_c1_ts),PP_CADR c0_c1_ts,PP_ENV(PP_CAR c0_c1_ts)),ps)))
#
#define PP_TO_LAMBDA_OP(t_ts,ps) PP_DISPATCH(PP_TO_LAMBDA_,t_ts)(PP_CAR t_ts,PP_CDR t_ts,ps)
#define PP_TO_LAMBDA_CLOSURE(t,ts,ps) ((LAMBDA(PP_VAR(t),PP_TERM(t)),ts),(PP_SUBST,(PP_ENV(t),ps)))
#define PP_TO_LAMBDA_LAMBDA(t,ts,ps) ((t,ts),ps)
#define PP_TO_LAMBDA_APPLY(t,ts,ps) ((t,ts),ps)
#define PP_TO_LAMBDA_SYMBOL(t,ts,ps) ((t,ts),ps)
#
#define PP_SUBST_OP(t_ts,env_ps) PP_DISPATCH(PP_SUBST_,t_ts)(PP_CAR t_ts,PP_CDR t_ts,PP_CAR env_ps,PP_CDR env_ps)
#define PP_SUBST_CLOSURE(t,ts,env,ps) ((ERROR CLOSURE: t,_),PP_SM_STOP)
#define PP_SUBST_LAMBDA(t,ts,env,ps) ((PP_TERM(t),ts),(PP_SUBST,(PP_ENV_SET(PP_VAR(t),PP_VAR(t),env),(PP_MK_LAMBDA,(PP_VAR(t),ps)))))
#define PP_SUBST_APPLY(t,ts,env,ps) ((PP_CDR t,(PP_CAR t,ts)),(PP_SUBST,(env,(PP_SWAP,(PP_SUBST,(env,(PP_MK_APPLY,ps)))))))
#define PP_SUBST_SYMBOL(t,ts,env,ps) ((PP_ENV_GET(t,env),ts),(PP_TO_LAMBDA,ps))
#
#/* Invokes the reducer */
#
#ifndef TERM
#define TERM ((AND,FALSE),TRUE)
#endif
#
PP_EVAL(TERM)
