#ifndef SM_HPP
#define SM_HPP
#
#/* Copyright (C) 2003  Vesa Karvonen
# *
# * Permission to copy, use, modify, sell and distribute this software is
# * granted provided this copyright notice appears in all copies. This
# * software is provided "as is" without express or implied warranty, and with
# * no claim as to its suitability for any purpose.
# */
#
#include "aux.hpp"
#
#/* A stack machine (can do 2^30-1 iterations - more than you want to wait) */
#
#define PP_SM(s,p) PP_CADR(_,PP_SM_0((s,p)))
#
#define PP_SM_OVER(s,p) PP_CAT(PP_SM_OVER_,PP_SM_OVER_IS_PAIR p)
#define PP_SM_OVER_PP_SM_OVER_IS_PAIR
#define PP_SM_OVER_IS_PAIR(f,s) 1
#
#define PP_SM_OVER_1(i) PP_SM_B##i
#define PP_SM_STOP(i)
#
#define PP_SM_CAR_OP(a,d) a##_OP
#
#define PP_SM_0(sp) PP_SM_OVER sp(0)sp
#define PP_SM_1(sp) PP_SM_OVER sp(1)sp
#define PP_SM_2(sp) PP_SM_OVER sp(2)sp
#define PP_SM_3(sp) PP_SM_OVER sp(3)sp
#define PP_SM_4(sp) PP_SM_OVER sp(4)sp
#define PP_SM_5(sp) PP_SM_OVER sp(5)sp
#define PP_SM_6(sp) PP_SM_OVER sp(6)sp
#define PP_SM_7(sp) PP_SM_OVER sp(7)sp
#define PP_SM_8(sp) PP_SM_OVER sp(8)sp
#define PP_SM_9(sp) PP_SM_OVER sp(9)sp
#define PP_SM_10(sp) PP_SM_OVER sp(10)sp
#define PP_SM_11(sp) PP_SM_OVER sp(11)sp
#define PP_SM_12(sp) PP_SM_OVER sp(12)sp
#define PP_SM_13(sp) PP_SM_OVER sp(13)sp
#define PP_SM_14(sp) PP_SM_OVER sp(14)sp
#define PP_SM_15(sp) PP_SM_OVER sp(15)sp
#define PP_SM_16(sp) PP_SM_OVER sp(16)sp
#define PP_SM_17(sp) PP_SM_OVER sp(17)sp
#define PP_SM_18(sp) PP_SM_OVER sp(18)sp
#define PP_SM_19(sp) PP_SM_OVER sp(19)sp
#define PP_SM_20(sp) PP_SM_OVER sp(20)sp
#define PP_SM_21(sp) PP_SM_OVER sp(21)sp
#define PP_SM_22(sp) PP_SM_OVER sp(22)sp
#define PP_SM_23(sp) PP_SM_OVER sp(23)sp
#define PP_SM_24(sp) PP_SM_OVER sp(24)sp
#define PP_SM_25(sp) PP_SM_OVER sp(25)sp
#define PP_SM_26(sp) PP_SM_OVER sp(26)sp
#define PP_SM_27(sp) PP_SM_OVER sp(27)sp
#define PP_SM_28(sp) PP_SM_OVER sp(28)sp
#define PP_SM_29(sp) PP_SM_OVER sp(29)sp
#
#define PP_SM_B0(s,p) PP_SM_1(PP_SM_1(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B1(s,p) PP_SM_2(PP_SM_2(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B2(s,p) PP_SM_3(PP_SM_3(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B3(s,p) PP_SM_4(PP_SM_4(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B4(s,p) PP_SM_5(PP_SM_5(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B5(s,p) PP_SM_6(PP_SM_6(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B6(s,p) PP_SM_7(PP_SM_7(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B7(s,p) PP_SM_8(PP_SM_8(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B8(s,p) PP_SM_9(PP_SM_9(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B9(s,p) PP_SM_10(PP_SM_10(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B10(s,p) PP_SM_11(PP_SM_11(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B11(s,p) PP_SM_12(PP_SM_12(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B12(s,p) PP_SM_13(PP_SM_13(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B13(s,p) PP_SM_14(PP_SM_14(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B14(s,p) PP_SM_15(PP_SM_15(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B15(s,p) PP_SM_16(PP_SM_16(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B16(s,p) PP_SM_17(PP_SM_17(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B17(s,p) PP_SM_18(PP_SM_18(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B18(s,p) PP_SM_19(PP_SM_19(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B19(s,p) PP_SM_20(PP_SM_20(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B20(s,p) PP_SM_21(PP_SM_21(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B21(s,p) PP_SM_22(PP_SM_22(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B22(s,p) PP_SM_23(PP_SM_23(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B23(s,p) PP_SM_24(PP_SM_24(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B24(s,p) PP_SM_25(PP_SM_25(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B25(s,p) PP_SM_26(PP_SM_26(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B26(s,p) PP_SM_27(PP_SM_27(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B27(s,p) PP_SM_28(PP_SM_28(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B28(s,p) PP_SM_29(PP_SM_29(PP_SM_CAR_OP p(s,PP_CDR p)))
#define PP_SM_B29(s,p) PP_SM_CAR_OP p(s,PP_CDR p)
#
#endif
